import Button from "@dftvue2-opentiny/vue-button";
import ButtonGroup from "@dftvue2-opentiny/vue-button-group";
import Collapse from "@dftvue2-opentiny/vue-collapse";
import CollapseItem from "@dftvue2-opentiny/vue-collapse-item";
import Input from "@dftvue2-opentiny/vue-input";
import { renderless as renderless$2, api as api$2 } from "@dftvue2-opentiny/vue-renderless/color-select-panel/vue";
import { defineComponent, setup as _setup, props, directive } from "@dftvue2-opentiny/vue-common";
import { renderless, api } from "@dftvue2-opentiny/vue-renderless/color-select-panel/hue-select/vue";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import { renderless as renderless$1, api as api$1 } from "@dftvue2-opentiny/vue-renderless/color-select-panel/alpha-select/vue";
import "@dftvue2-opentiny/vue-theme/color-select-panel/index.css";
import Clickoutside from "@dftvue2-opentiny/vue-renderless/common/deps/clickoutside";
import "@dftvue2-opentiny/vue-locale";
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-color-select-panel__wrapper__inner"
  }, [_c("div", {
    ref: "wrapper",
    staticClass: "tiny-color-select-panel__wrapper__inner__color-select",
    style: {
      background: _vm.state.background
    }
  }, [_c("div", {
    staticClass: "white"
  }), _c("div", {
    staticClass: "black"
  }), _c("div", {
    ref: "cursor",
    staticClass: "cursor"
  })]), _c("div", {
    ref: "bar",
    staticClass: "tiny-color-select-panel__wrapper__inner__hue-select"
  }, [_c("div", {
    ref: "thumb"
  })])]);
};
var staticRenderFns$2 = [];
var __vue2_script$2 = defineComponent({
  emits: ["hue-update", "sv-update"],
  props: {
    color: {
      type: String
    },
    alpha: {
      type: Boolean
    }
  },
  setup: function setup(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2, null, null, null);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var HueSelect = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    ref: "alphaWrapper",
    staticClass: "tiny-color-select-panel__wrapper__alpha"
  }, [_c("div", {
    ref: "slider",
    staticClass: "tiny-color-select-panel__wrapper__alpha__slider",
    style: {
      background: _vm.state.background
    }
  }), _c("div", {
    ref: "alphaThumb",
    staticClass: "tiny-color-select-panel__wrapper__alpha__thumb",
    style: {
      top: 0,
      left: 0
    }
  })]);
};
var staticRenderFns$1 = [];
var __vue2_script$1 = defineComponent({
  emits: ["alpha-update"],
  props: {
    color: {
      type: String
    }
  },
  setup: function setup2(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1
    });
  }
});
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1, null, null, null);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var AlphaSelect = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.state.isShow ? _c("div", {
    directives: [{
      name: "clickoutside",
      rawName: "v-clickoutside",
      value: _vm.onCancel,
      expression: "onCancel"
    }],
    staticClass: "tiny-color-select-panel__wrapper",
    on: {
      "click": function click($event) {
        $event.stopPropagation();
      }
    }
  }, [_c("hue-select", {
    attrs: {
      "color": _vm.state.hex
    },
    on: {
      "hue-update": _vm.onHueUpdate,
      "sv-update": _vm.onSVUpdate
    }
  }), _vm.alpha ? _c("alpha-select", {
    attrs: {
      "color": _vm.state.res
    },
    on: {
      "alpha-update": _vm.onAlphaUpdate
    }
  }) : _vm._e(), _c("div", {
    staticClass: "tiny-color-select-panel__wrapper__tools"
  }, [_c("tiny-input", {
    model: {
      value: _vm.state.res,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "res", $$v);
      },
      expression: "state.res"
    }
  }), _c("tiny-button-group", [_c("tiny-button", {
    attrs: {
      "type": "text"
    },
    on: {
      "click": _vm.onCancel
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.colorSelectPanel.cancel")) + " ")]), _c("tiny-button", {
    on: {
      "click": _vm.onConfirm
    }
  }, [_vm._v(" " + _vm._s(_vm.t("ui.colorSelectPanel.confirm")) + " ")])], 1)], 1), _c("tiny-collapse", [_vm.state.enableHistory ? _c("tiny-collapse-item", {
    attrs: {
      "title": _vm.t("ui.colorSelectPanel.history"),
      "name": "history"
    }
  }, [_c("div", {
    staticClass: "tiny-color-select-panel__history"
  }, _vm._l(_vm.state.stack, function(color) {
    return _vm.state.stack.length ? _c("div", {
      staticClass: "tiny-color-select-panel__history__color-block",
      style: {
        background: color
      },
      on: {
        "click": function click() {
          return _vm.onHistoryClick(color);
        }
      }
    }) : _c("span", [_vm._v(_vm._s(_vm.t("ui.colorSelectPanel.empty")))]);
  }), 0)]) : _vm._e(), _vm.state.enablePredefineColor ? _c("tiny-collapse-item", {
    attrs: {
      "title": _vm.t("ui.colorSelectPanel.predefine"),
      "name": "predefine"
    }
  }, [_c("div", {
    staticClass: "tiny-color-select-panel__predefine"
  }, _vm._l(_vm.state.predefineStack, function(color) {
    return _vm.state.predefineStack.length ? _c("div", {
      staticClass: "tiny-color-select-panel__predefine__color-block",
      style: {
        background: color
      },
      on: {
        "click": function click() {
          return _vm.onPredefineColorClick(color);
        }
      }
    }) : _c("span", [_vm._v(_vm._s(_vm.t("ui.colorSelectPanel.empty")))]);
  }), 0)]) : _vm._e()], 1)], 1) : _vm._e();
};
var staticRenderFns = [];
var __vue2_script = defineComponent({
  emits: ["update:modelValue", "cancel", "confirm", "hue-update", "sv-update"],
  props: [].concat(props, ["modelValue", "visible", "alpha", "history", "predefine"]),
  components: {
    hueSelect: HueSelect,
    alphaSelect: AlphaSelect,
    TinyButton: Button,
    TinyButtonGroup: ButtonGroup,
    TinyInput: Input,
    TinyCollapse: Collapse,
    TinyCollapseItem: CollapseItem
  },
  directives: directive({
    Clickoutside
  }),
  setup: function setup3(props2, context) {
    return _setup({
      props: props2,
      context,
      renderless: renderless$2,
      api: api$2
    });
  }
});
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export {
  pc as default
};
